
#load'C:\Users\Keith\Documents\ShopProjects\TestPlugins\BoardToLayerK2-1.rb'

# Name :          BoardToLayerK2  ###
# Date :	     8 24 2010
# Description :   Place the Component on a new layer named from the component
#                 Layer name includes prefix A##- where ## is 2 digit no (01...99)

# Author :       Keith Krueger (with a big help from plugin forum:)
#    
require 'sketchup.rb'


def Comp_to_layer()
      model=Sketchup.active_model
      layers = model.layers
      ss=model.selection
      entity = ss.first
      pages = model.pages
      count = pages.count
      length = layers.length     
      definitions = model.definitions
    
    #Initialize Variables
      userLName = []
      cName = []
      userCName = []
              
    # Check to see if component selected
      if ss[0].class != Sketchup::ComponentInstance
        UI.messagebox("Select a Component to Name a Layer after...")
        return nil
      end#if
      cName=ss[0].definition.name
      if not cName or cName==""
        UI.messagebox("Select a NAMED Component to Name a Layer after...")
        return nil
      end#if
      
    # This Section Provides the Layer No Input as Text      		
      @@layerno="01"  #Provides Starting No for New Dwg
      length = layers.length
      if length >1
        lname = 0
        i=0
        loop do
          i += 1
          break if i==length
          layer2 = layers[length-i]
          lname = layer2.name
          break if lname[0,1]=="A" and lname[3,1]=="-"  
        end
        name_no=lname[1,2].to_i
        next_name_no=(name_no+1).to_s
        if next_name_no.length < 2 
          @@layerno="0"+next_name_no
        else
          @@layerno=(name_no+1).to_s
        end
      end
      
     #Component Name Input Box
      loop do
      componentnameunique = ""
      # Component Name Input Box
      prompts = [$exStrings.GetString("Component Name")]
      values = [cName]
          
      # Now display the inputbox
      results = inputbox prompts, values, $exStrings.GetString("Component New Name")
            
      return if not results # This means that the user canceld the operation
    
      userCName = results[0]

      UI.messagebox ("User entered .. " + userCName + "  .. for Component Name")# Debug

      if userCName ==  cName
        UI.messagebox "Insert input loop break and keep existing component name"# Debug
        break
      end#if

      componentdefinition = definitions[userCName]

      UI.messagebox ("test variable " + componentdefinition.to_s.length.to_s)# Debug
      UI.messagebox ("compared to " + componentnameunique.length.to_s )# Debug

      componentnameunique = componentdefinition.to_s.length > componentnameunique.length ?  "no" :  "yes"
      if componentnameunique == "yes"
         UI.messagebox "Insert input loop break component name was unique"# Debug
         break
      else
         UI.messagebox ("Component name .. " + userCName + "  ..  not unique enter new name")
      end#if

      end#loop
      # Change Component Name
      if  userCName !=  cName
        ss[0].definition.name=userCName
        cName=ss[0].definition.name
        if cName!=userCName
          UI.messagebox("Caution SketchUP added #No to make Name Unique")
        end #if
      end#if                                    

#UI.messagebox "Change Component Name & Program continues to change layer"#Debug

    
    # This Section adds leading "0" if missing
      if @@layerno.length < 2 
        layerno="0"+@@layerno
      else
        layerno=@@layerno
      end  
      anewname = "A" + layerno + "-" + cName
      
    # Create new layer for Part Assembly
      if layers[anewname]
	      UI.messagebox("Layer \"#{anewname}\" exists, exiting.")
      end
      layer = layers.add anewname
      pb = layer.page_behavior = LAYER_IS_HIDDEN_ON_NEW_PAGES
      model.pages.each { |p| p.set_visibility( layer, false ) }    
      entity.layer=(layers[anewname])
      
    # Make New Part Component visible on "Assembly" Page   
      page = pages["Assembly"]
      page.set_visibility(layers [anewname] ,true)
            
    # Place new named component on new layer
      entity = model.selection[0]
      entity.layer=(layers[anewname])  
      
                
end#def


if(not file_loaded?("BoardToLayerK2.rb")) 
ss=Sketchup.active_model.selection
  UI.add_context_menu_handler do |menu|
    menu.add_separator if ss[0].class ==Sketchup::ComponentInstance
   menu.add_item("Board/Comp to New layer"){Comp_to_layer()}if ss[0].class==Sketchup::ComponentInstance
  end
end
file_loaded ("BoardToLayerK2.rb")
